﻿<%@ Page Language="C#" %>

<%@ OutputCache Location="None" VaryByParam="None" %>
<%@ Import Namespace="System" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>
<%@ Import Namespace="System.Web.UI.WebControls" %>
<%@ Import Namespace="System.Data.OleDb" %>
<%@ Import Namespace="System.Globalization" %>
<%@ Import Namespace="System.Threading" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<script runat="server">
    
    //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    // To convert the SQL Server versions to MS Access do the following:-
    //   Replace the 2 DSN lines
    //   Replace all code of:-   SQLCommand   to   OleDbCommand
    //   Replace all code of:-   SQLDatareader   to   OleDbDatareader
    //   Replace Dates from '  to #   (do not need ' for SQL Server)    (eg strStartDate = "#" & strStartDate & "#")
    //   Change Function DateConvitfromformUS, also  (see comments in Function itself)
    //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

    int intSkipCount;
    long intTotalPages;
    int intPageSize;
    int intCurrentPage;
    long intTotalNoRecords;
    int intRowID;
    string strSortField;
    string strPKIDNEW;
    string strAction;
    string strpageload;

    //NET 1.1
    //SqlConnection objConn = new SqlConnection(ConfigurationSettings.AppSettings["DSN"]);
    //NET 2.0
    SqlConnection objConn = new SqlConnection(ConfigurationManager.AppSettings["DSN"]);

    //=======================================================================================
    // NOTE:-
    // Code that can be Customised is marked by &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
    //
    //=======================================================================================

    void Page_Load()
    {

        //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
        //Search criteria automatic Javascript submissions, if there is any selection criteria (OPTIONAL, to be taken out if no Search criteria)
        //-------------------------------------------------------------------------------------------------
        //Search drop-down list
        //ddldropdown.Attributes.Add("OnChange", "javascript: Searchit('noprogressbar');"); 

        //Search text field               
        textsearch.Attributes.Add("OnKeyUp", "javascript: Searchit('progressbar');");            //this like Google Suggest (on a textbox input)
        //textsearch.Attributes.Add("autocomplete", "off");                                                        //Alternative way of setting autocomplete on a form control
        //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&


        //ProgressBar.Value = "NotWaiting";                                                                                //so as to Close progressBar window, if it is shown

        if (!IsPostBack)               //initially coming into this web page from another external web page
        {
            //response.write("Coming initially or back into page externally from another page" & "<br>");
            strAction = Convert.ToString(Request.QueryString["action"]);                                                                  //get action from another web page

            //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
            //Sorting criteria.
            //----------------------------------------------------------------------------------------
            //strSortField = "Array_Name, PK_ID";  
            strSortField = "PK_ID";                           //Initial Sorting by, and must be unique (Change PK_ID to Primary Key field name you are using)
            //if (Session["SortDirection"] == null
            //     || Convert.ToString(Session["SortDirection"]) == "")
            //{
            //    Session["SortDirection"] = " asc";
            //}
            //Session["SortDirection"] = "desc";
            //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

            intSkipCount = 0;
            intCurrentPage = 1;
            intRowID = 1;
            strpageload = "initload('" + strSortField + "')";
        }
        else   //postback within page (should not happen now, with AJAX)
        {
            //strpageload =  "";
            //response.write("Doing Postback within page " & "<br>");

        }

    }

</script>

<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <title>Untitled Page</title>
    <meta http-equiv="PRAGMA" content="NO-CACHE" />
    <meta http-equiv="imagetoolbar" content="NO" />
    
    <link href="ModalDialogs.css" rel="stylesheet" type="text/css" />
    
    <style type="text/css">
        /* Next styles is for Header Sorting */
        .alternatingrowstyle
        {
            background-color: #F0F0F6;
        }
        /* END of styles is for Header Sorting */
     </style>
        
</head>

<script type="text/javascript" src="ajax_xmlhttp.js">
</script>

<!-- Next 2 lines are old code for including Javascript, so as not to be displayed when viewing source-->
<!--Script LANGUAGE="JavaScript" src="kgrid_list.js">
</Script>-->

<script type="text/javascript">
  
// Global set variables
var CHKDEL = 0;

//==============================================================================================================
//NEXT Part is AJAX Remote Scripting +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//==============================================================================================================
                function show_pageID(actionit, page_ID, sortby, dosort)
                {                 
                   //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                   //Change ajax called program name 
                   var requestURLIT = 'ajax_kgrid_list.aspx?action=' + actionit     
                   //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                   
                   var url = requestURLIT + '&sortby=' + sortby + '&pageid=' + page_ID + '&dosort=' + dosort

                    //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                   //Add Search criteria next (Note:- Must comment out if no search criteria used)
                   url = url + '&textsearch=' + escape(document.getElementById('textsearch').value)
                   //url = url + '&dropdownsearch=' + document.getElementById('ddldropdown').value
                   //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

                   //alert("url is " + url);         //used for debug testing
                   xmlHttp = GetXmlHttpObject(stateChangeHandlerPAGE);
	               xmlHttp_Get(xmlHttp, url); 
                }


                function show_nextpage(actionit, sortby, page_ID, skipcount)
                {                       
                   //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                   //Change ajax called program name 
                   var requestURLIT = 'ajax_kgrid_list.aspx?action=' + actionit
                   //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                   
                   var url = requestURLIT + '&sortby=' + sortby + '&pageid=' + page_ID + '&skip=' + skipcount

                   //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                   //Add Search criteria next  (Note:- Must comment out if no search criteria used)
                   url = url + '&textsearch=' + escape(document.getElementById('textsearch').value)
                   //url = url + '&dropdownsearch=' + document.getElementById('ddldropdown').value
                   //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

                   //alert("url is " + url);         //used for debug testing
                   xmlHttp = GetXmlHttpObject(stateChangeHandlerPAGE);
	               xmlHttp_Get(xmlHttp, url);  
	             }


                //Checkbox function
                function show_chkpage(actionit, indxk1)
                {                       
                   //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                   //Change ajax called program name (ie AJAX_FLAG)
                   var requestURLIT = 'AJAX_ARRAYS_FLAG.aspx?action=' + actionit 
                   //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                   
                   var url = requestURLIT + '&num=' + indxk1 

                   //alert("url is " + url);          //used for debug testing
                   xmlHttp = GetXmlHttpObject(stateChangeHandlerCHK); 
                   xmlHttp_Get(xmlHttp, url); 
	            }
           

                function delrecord(actionit, indxk, sortby, row_ID, page_ID, skipcount, pagesize)
                {                       
                   //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                   //Change ajax called program name (ie AJAX_DEL)
                   var requestURLIT = 'AJAX_ARRAYS_DEL.aspx?action=' + actionit
                   //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                   
                   var url = requestURLIT + '&num=' + indxk + '&sortby=' + sortby + '&pageid=' + page_ID + '&skip=' + skipcount + '&pagesize=' + pagesize

                   //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                   //Add Search criteria next (Note:- Must comment out if no search criteria used)
                   url = url + '&textsearch=' + escape(document.getElementById('textsearch').value)
                   //url = url + '&dropdownsearch=' + document.getElementById('ddldropdown').value
                   //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

                   //alert("about to ClearTimeout ");
                   //Stop the Beginrefresh temporarily, when doing a Delete 
                   clearTimeout(CHKDEL);
                   if(CHKDEL) 
                    {
                      clearTimeout(CHKDEL);
                      CHKDEL  = 0;
                     }

                   //alert("url is " + url);          //used for debug testing
                   xmlHttp = GetXmlHttpObject(stateChangeHandlerDEL); 
                   xmlHttp_Get(xmlHttp, url); 
	            }
           

                //Edit field on the fly
                function update_arrayname(actionit, indxk1, cellval, sortby1, row_ID1, page_ID1, skipcount1)
                {                       
                   //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                   //Change ajax called program name (ie AJAX_ARRAY_UPDATE)
                   var requestURLIT = 'AJAX_ARRAYS_UPDATE.aspx?action=' + actionit 
                   //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                   
                   var url = requestURLIT + '&num=' + indxk1 
                
                   url = url + '&cellval=' + escape(cellval)

                   //alert("url is " + url);
                   xmlHttp = GetXmlHttpObject(stateChangeHandlerCHK); 
                   xmlHttp_Get(xmlHttp, url); 
	            }


                //Used with ADD popup
                function show_currentpage(actionit, indxk, sortby, row_ID, page_ID, skipcount)
                {                       
                   //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                   //Change ajax called program name
                   var requestURLIT = 'ajax_kgrid_list.aspx?action=' + actionit 
                   //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                   
                   var url = requestURLIT + '&num=' + indxk + '&sortby=' + sortby + '&pageid=' + page_ID + '&rowid=' + row_ID + '&skip=' + skipcount

                   //alert("url is " + url);          //used for debug testing
                   xmlHttp = GetXmlHttpObject(stateChangeHandlerPAGE);      
                   xmlHttp_Get(xmlHttp, url); 
	            }
               

                //This function is to check if the record you are on has been Deleted by another User 
                // It is invoked every 10 seconds from Beginrefresh function, which loops within itself
                function check_record(indxk)
                {                       
                   //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                   //Change ajax called program name (ie AJAX_CHECK)
                   var requestURLIT = 'AJAX_ARRAYS_CHECK.aspx?action=init'
                   //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                   
                   var url = requestURLIT + '&num=' + indxk
                  
                   //alert("url is " + url);          //used for debug testing
                   xmlHttpCheck = GetXmlHttpObject(stateChangeHandlerCHECK); 
	               xmlHttp_Get(xmlHttpCheck, url); 
	            }
             

                function show_report(actionit, page_ID, sortby)
                {                 
                   //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                   //Change ajax called program name 
                   var requestURLIT = 'ARRAYS_REPORT.aspx?action=' + actionit     
                   //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                   
                   var url = requestURLIT + '&sortby=' + sortby + '&pageid=' + page_ID

                    //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                   //Add Search criteria next (Note:- Must comment out if no search criteria used)
                   url = url + '&textsearch=' + escape(document.getElementById('textsearch').value)
                   //url = url + '&dropdownsearch=' + document.getElementById('ddldropdown').value
                   //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

                   //alert("url is " + url);         //used for debug testing
                   xmlHttp = GetXmlHttpObject(stateChangeHandlerREPORT);
	               xmlHttp_Get(xmlHttp, url); 
                 }


//=======================================================================================================================================================
// Next functions are run after the above functions, so as to see when the Remote page has been completed
// stateChangeHandler will fire when the state has changed, i.e. data is received back 
// This is non-blocking (asynchronous) 
//=======================================================================================================================================================
                 function stateChangeHandlerPAGE() 
	             { 
                  var rowID1;
		          //readyState of 4 or 'complete' represents that data has been returned 
		          if (xmlHttp.readyState == 4 || xmlHttp.readyState == 'complete')
                  { 
		            //Gather the results from the callback 
		            var str = xmlHttp.responseText; 

		            //Populate the innerHTML of the div with the results 
                    document.getElementById('nameList2').innerHTML = str;

                    rowID1 = document.getElementById('RowIDGet').value;
                    //alert("rowID1 is " + rowID1);
                            
                    //Hide Progress bar
                    document.getElementById("pnlpopupprogress").style.display = "none";
                    document.getElementById('overlayprogress').style.visibility="hidden";

                    //Check if NO records found at all
                    if (document.getElementById('chkresetcriteria').value  == ' No Records ') 
                    {
                       //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                       //(NOTE:- This part can be commented out if no framed detail record) 
                       //parent.ARRAYSUPD.location.href="BLANK.aspx?action=init";
                       //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                    }
                    else
                    {
                      resetablebg();
                      //set column sort header to a different background color
                      setBgColor(document.getElementById('SortFieldGet').value);
                      var table = document.getElementById('myTable');
                      if (table)   
                      {
                        //Highlight Row of Page
                        // table.rows[rowID1].style.backgroundColor="silver";
                       //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                       //Highlight Input Textbox row as well (Comment out if no Input Textbox used in List)
                       //document.getElementById('aa' + rowID1 + 'c7').style.backgroundColor="silver";
                       //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                      }   
 
                       //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                       //display record in bottom framed page  (NOTE:- This part can be commented out if no framed detail record)
                       //parent.ARRAYSUPD.location.href="ARRAYS_UPD.aspx?action=upd" +
                       //      "&num=" + document.getElementById('textcurrentpkid').value;
                       //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                                                             
                    }

	              } 
	              
	             } 


//Next function is just for delaying the Error Message 
//---------------------------------------------------------------
function ShowAlert(str1) 
{ 
 alert(str1); 
}
         
               //CheckBox in List or edit field on the fly
	function stateChangeHandlerCHK() 
	{ 
		//readyState of 4 or 'complete' represents that data has been returned 
		if (xmlHttp.readyState == 4 || xmlHttp.readyState == 'complete')
                               { 
		   //Gather the results from the callback 
		   var str = xmlHttp.responseText; 
                                   //alert("str is " + str);

		  //In this case we DO NOT Populate the innerHTML of the div with the results, as clicking on Checkbox
				
                                  //document.getElementById("ProgressBar").value = "NOTwaiting";
                                  document.getElementById("pnlpopupprogress").style.display = "none";
                                  document.getElementById('overlayprogress').style.visibility="hidden";
                                  
                                 //If validation Error found, then display error concerned
                                  if (str.substring(0,5) == "Error")
                                  {
                                       setTimeout("ShowAlert(' " + str + " ')",200)
                                       //alert(str);      
                                   }
                                   else
                                   {
                                     //If No Error then
                                     //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                                     //display record in bottom framed page  (NOTE:- This part can be commented out if no framed detail record)
                                     //parent.ARRAYSUPD.location.href="ARRAYS_UPD.aspx?action=upd" +
                                                //              "&num=" + document.getElementById('textcurrentpkid').value;
                                     //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                                   }
                                                            
	               } 
	} 
           
  
	function stateChangeHandlerDEL() 
	{ 
                            var rowID1;
		//readyState of 4 or 'complete' represents that data has been returned 
		if (xmlHttp.readyState == 4 || xmlHttp.readyState == 'complete')
                            { 
		    //Gather the results from the callback 
  		    var str = xmlHttp.responseText; 

	             	    //Populate the innerHTML of the div with the results
                                document.getElementById('nameList2').innerHTML = str;

                                rowID1 = document.getElementById('RowIDGet').value;

                                //document.getElementById("ProgressBar").value = "NOTwaiting";
                                document.getElementById("pnlpopupprogress").style.display = "none";
                                document.getElementById('overlayprogress').style.visibility="hidden";

                               //Check if NO records found at all
                               if (document.getElementById('chkresetcriteria').value  == ' No Records ') 
                                {
                                    //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                                    //(NOTE:- This part can be commented out if no framed detail record) 
                                    //parent.ARRAYSUPD.location.href="BLANK.aspx?action=init";
                                    //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                                }
                               else
                               {
                                 resetablebg();
                                 //set column sort header to a different background color
                                 setBgColor(document.getElementById('SortFieldGet').value);
                                 var table = document.getElementById('myTable');
                                 if (table)   
                                  {
                                    //Highlight 1st Row of new Page
                                    table.rows[rowID1].style.backgroundColor="silver";
                                    //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                                    //Highlight Input Textbox row as well (Comment out if no Input Textbox used in List)
                                    document.getElementById('aa' + rowID1 + 'c7').style.backgroundColor="silver";
                                   //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                                  }   
                                   //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                                   //display record in bottom framed page  (NOTE:- This part can be commented out if no framed detail record)
                                   //parent.ARRAYSUPD.location.href="ARRAYS_UPD.aspx?action=upd" +
                                    //                          "&num=" + document.getElementById('textcurrentpkid').value;
                                   //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

                               }                      
        
                               //Start Time again to check for Deleted record by another User, it was stopped temporarily
                               //while doing Delete by myself
                               limit="0:10";
                               parselimit=limit.split(":");
                               parselimit=parselimit[0]*60+parselimit[1]*1;
                               //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                               //Uncomment next line if using Multi_user check of Deleted record by another User
                               //Beginrefresh()
                              //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

	             } 
	  } 
                

                //Automatic Checking of a Deleted record
                function stateChangeHandlerCHECK() 
                { 
		//readyState of 4 or 'complete' represents that data has been returned 
		if (xmlHttpCheck.readyState == 4 || xmlHttpCheck.readyState == 'complete')
                            { 
		   //Gather the results from the callback 
		   var str = xmlHttpCheck.responseText; 
                             
                               //document.getElementById("ProgressBar").value = "NOTwaiting";
                               document.getElementById("pnlpopupprogress").style.display = "none";
                               document.getElementById('overlayprogress').style.visibility="hidden";
                               
                               //alert("str is " + str);
                               //Check if record has been Deleted
                              if (str == "Nothing")
                               {
                                  //alert("Record has not been Deleted");
                                 // alert(str);      
                               }
                              else
                               {
                                alert("Warning! - This record has been Deleted, about to do refresh");
                                //Redisplay same Page again
                                var sortby = document.getElementById('SortFieldGet').value;
                                var page_ID = document.getElementById('CurrentPageGet').value;  
                                var dosort = "NoSorting";
                                show_pageID('pageid', page_ID, sortby, dosort);
                             
                               }

	             } 
	  } 
                 

                  function stateChangeHandlerREPORT() 
	  { 
                            var rowID1;
		//readyState of 4 or 'complete' represents that data has been returned 
	            if (xmlHttp.readyState == 4 || xmlHttp.readyState == 'complete')
                            { 
		//Gather the results from the callback 
		var str = xmlHttp.responseText; 

                                //document.getElementById("ProgressBar").value = "NOTwaiting";
                                document.getElementById("pnlpopupprogress").style.display = "none";
                                document.getElementById('overlayprogress').style.visibility="hidden";
                                
                                var modalWinreppopup
                                if(navigator.appName == "Microsoft Internet Explorer")
                                {
                                  modalWinreppopup = open('PRINT_REPORT.html?action=init' ,+
                                      'REPPOPUP','height=650,width=780,left=5,top=5,toolbar=1,menubar=1,location=1,scrollbars=1');
                                 modalWinreppopup.focus();
                                 }
                                else    //Not IE
                                 {
                                   modalWinreppopup = open("PRINT_REPORT.html?action=init"
                                     , "REPPOPUP",
                                     "dialog=no,modal=yes,dependent=yes,alwaysraised=yes,top=5,left=5,width=780,height=650");
                                   modalWinreppopup.focus();
                                 }


	             } 
	} 

//==============================================================================================================
//END Part is AJAX Remote Scripting +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//==============================================================================================================



function initload(sortby)
{
 //document.getElementById('textsearch').focus();    //Optional initial focus on a control on form
 //Progress Bar Display
 document.getElementById("pnlpopupprogress").style.display = "block";
 document.getElementById('overlayprogress').style.visibility="visible";
 //END Progress Bar Display
 var page_ID = 1;
 var dosort = "NoSorting";
 show_pageID('firstpage', page_ID, sortby, dosort);
}


function initsetablebg(page_ID, row_ID)
{
 var table = document.getElementById('myTable');
 if (table)   
  {
     //Re-Highlight row that has been Updated
     table.rows[row_ID].style.backgroundColor="silver";
  }             
}
function resetablebg()
{
 var table = document.getElementById('myTable');
 if (table)   
  {
   //Make all rows white again
   for (var r = 0; r < table.rows.length; r++)
   {
     table.rows[r].style.backgroundColor="white";
     //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
     //Reset Input Textbox row as well (Comment out if no Input Textbox used in List)
     //document.getElementById('aa' + r + 'c7').style.backgroundColor="white";
     //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
   }
  }             
}
function setBgColor(id) 
{
  //alert("in setBgcolor");
 var sortid;
 var table = document.getElementById(id);
 //sortid = id.replace(/asc/i, "");
 //sortid = id.replace(/desc/i, "");

 //alert("header id is:- " + sortid);
 if (table)
  {
     document.getElementById(id).style.backgroundColor = "blue";
     //document.getElementById(sortid).style.backgroundColor = "blue";
  }
}



function DelClick(indxk, row_ID, page_ID, skipcount, sortby, pagesize, arrayname)
{
 //alert("Clicked on DELETE button");
 resetablebg();
 var table = document.getElementById('myTable');
 if (table)   
  {
     table.rows[row_ID].style.backgroundColor="silver";
     //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
     //Highlight Input Textbox row as well (Comment out if no Input Textbox used in List)
     //document.getElementById('aa' + row_ID + 'c7').style.backgroundColor="silver";
     //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
  }   

  //Set current PKID and RowID for storage
  document.getElementById('textcurrentpkid').value = indxk;
  document.getElementById('RowIDGet').value = row_ID;

  input_box=confirm("Do you wish to Delete this record? \n" + arrayname);
  if (input_box==true)
  {
      //Progress Bar Display
      document.getElementById("pnlpopupprogress").style.display = "block";
      document.getElementById('overlayprogress').style.visibility="visible";
      //END Progress Bar Display
      delrecord('delpage', indxk, sortby, row_ID, page_ID, skipcount, pagesize);
  }
  else  
  {
    //nothing
  }
}



function Detail1(indxk, row_ID, page_ID, skipcount, sortby, pagesize)
{
 //alert("rowid is " + row_ID);
 resetablebg();
 setBgColor(sortby);
 var table = document.getElementById('myTable');
 if (table)   
  {
     table.rows[row_ID].style.backgroundColor="silver";
     //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
     //Highlight Input Textbox row as well (Comment out if no Input Textbox used in List)
     //document.getElementById('aa' + row_ID + 'c7').style.backgroundColor="silver";
     //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
  }   


   //New KLE Code for IFRAME POPUP alternative
   var ifram = document.getElementById('iframeupd');
   ifram.src = "OWNER_UPDATE.aspx?action=upd" +
                            "&num=" + indxk;
   //ifram.src = ifram.src;                           
   document.getElementById("iframediv").style.display = "block";
   document.getElementById('overlayprogress').style.visibility="visible";   //shows gray background
   overlay();  //show iframe (popup)
                           
}



function CloseUpd()
{
 document.getElementById("iframediv").style.display = "none";
 document.getElementById('overlayprogress').style.visibility="hidden";  //hides gray background
 overlay();
}



function Searchit(action1)
{
 var sortby = document.getElementById('SortFieldGet').value;
 var page_ID = 1;

 if (action1 != "noprogressbar")    //ie do not show progress bar for Google like suggest on textarray field
 {
  //Progress Bar Display
  document.getElementById("pnlpopupprogress").style.display = "block";
  document.getElementById('overlayprogress').style.visibility="visible";
  //END Progress Bar Display
 }

 var dosort = "NoSorting";
 show_pageID('firstpage', page_ID, sortby, dosort);
}


function SearchReset()
{
 //window.location.reload();    //Not recommended
 //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
 //Change kgrid_list to required name
 document.location.href="kgrid_list.aspx?action=init"
 //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
}


function Reportit()
{
 var sortby = document.getElementById('SortFieldGet').value;
 var page_ID = 1;
 
 //Progress Bar Display
 document.getElementById("pnlpopupprogress").style.display = "block";
 document.getElementById('overlayprogress').style.visibility="visible";
 //END Progress Bar Display

 show_report('firstpage', page_ID, sortby);
}


function PageID(page_ID, sortby)
{
//alert("sortby is " + sortby);
 if (page_ID > 5)
 {
  //Progress Bar Display
  document.getElementById("pnlpopupprogress").style.display = "block";
  document.getElementById('overlayprogress').style.visibility="visible";
  //END Progress Bar Display
 }

 var dosort = "NoSorting";
 show_pageID('pageid', page_ID, sortby, dosort);
}


function NextPageit(page_ID, sortby, skipcount)
{

 if (page_ID > 5)
 {
  //Progress Bar Display
  document.getElementById("pnlpopupprogress").style.display = "block";
  document.getElementById('overlayprogress').style.visibility="visible";
  //END Progress Bar Display
 }
             
 show_nextpage('nextpage', sortby, page_ID, skipcount);       
}

function PrevPageit(page_ID, sortby, skipcount)
{
 //alert("sortby is " + sortby);
 if (page_ID > 5)
 {
  //Progress Bar Display
  document.getElementById("pnlpopupprogress").style.display = "block";
  document.getElementById('overlayprogress').style.visibility="visible";
  //END Progress Bar Display
 }
 
 show_nextpage('prevpage', sortby, page_ID, skipcount);
}

function LastPageit(page_ID, sortby, skipcount)
{
 //Progress Bar Display
 document.getElementById("pnlpopupprogress").style.display = "block";
 document.getElementById('overlayprogress').style.visibility="visible";
 //END Progress Bar Display
 
 show_nextpage('lastpage', sortby, page_ID, skipcount);
}


function Add1(page_ID, skipcount, sortby, pagesize)
{
 //Display Add new record page in bottom frame
 //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
 //(NOTE:- This part can be commented out if no framed detail record)
 //parent.ARRAYSUPD.location.href="ARRAYS_ADD.aspx?action=upd" +
 //                            "&num=" + document.getElementById('textcurrentpkid').value;
 //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                                                  
}

function Sort1(page_ID, skipcount, sortby, pagesize)
{
//alert("Clicked on SORT column");
//alert("Sort by is:- " + sortby);
var page_ID2 = 1;
var dosort = "Sorting";
//var sortby7 = document.getElementById('SortFieldGet').value; //innerHtml
show_pageID('firstpage', page_ID2, sortby, dosort);                                                          
}


//Open or Closes iframe modal fake popup
function overlay() 
{
    //alert("open overlay");
	el = document.getElementById("overlay2");
	//el.style.visibility = (el.style.visibility == "visible") ? "hidden" : "visible";
    el.style.display = (el.style.display == "block") ? "none" : "block";
}

</script>

<body onload="<%=strpageload%>" bgcolor="White">
    <form id="form1" runat="server">
    <!--&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&-->
    <!-- Search Criteria -->
    <!--&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&-->
    <asp:Label ID="lbltext" Style="font-weight: normal; font-size: 12px; z-index: 100;
        left: 17px; color: black; font-style: normal; font-family: arial; position: absolute;
        top: 48px; background-color: white" runat="server" Height="11" Width="108">
              Last Name Search:
    </asp:Label>
    <asp:TextBox ID="textsearch" Style="position: absolute; left: 126px; top: 46px; width: 125px;"
        TabIndex="2" runat="server">
    </asp:TextBox>
    <!--&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&-->
    <!-- END Search Criteria -->
    <!--&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&-->
    <!--Reset Button using only Javascript-->
    <div style="position: absolute; left: 260px; top: 45px; z-index: 100;">
        <input id="Button344" type="button" onclick="SearchReset()" style="text-align: center"
            value="Reset" />
    </div>
    
    <div id="nameList2" style="position: absolute; left: 15px; top: 77px; z-index: 100">
    </div>
    
    
    <div id="Div1" class="modalBackground2" style="position: absolute; left: 1px; visibility: hidden;
        top: 1px; height: 900px; width: 1900px; z-index: 300">
    </div>
    <div id="overlay2">
        <div>
            <div id="iframediv" style="position: absolute; left: 15px; top: 5px; display: none;
                background-color: white; z-index: 400">
                <iframe id="iframeupd" width='600' height='200' frameborder='0' scrolling='no' src=''>
                </iframe>
            </div>
        </div>
    </div>
    
    
    <!--Next 2 divs are for Progress Bar display-->
    <!-- MANDATORY -->
    <div id="overlayprogress" class="modalBackground2" style="position: absolute; left: 1px;
        visibility: hidden; top: 1px; height: 100%; width: 100%; z-index: 300">
    </div>
    <div id="pnlpopupprogress" class="updateProgress2" style="display: none; position: absolute;
        top: 250px; left: 200px; z-index: 400">
        <div align="center" style="margin-top: 12px;">
            <img src="images/simple.gif" alt="Progress" />
            <span class="updateProgressMessage">Processing ...</span>
        </div>
    </div>


    <script type="text/javascript">

//------------------------------------------------------------------------------------------------------------------------
//DISABLE RIGHT-CLICK button - OPTIONAL
//------------------------------------------------------------------------------------------------------------------------
//Disable right mouse click Script
var message="Function Disabled!";

function clickIE(){
if (event.button==2){
//alert(message);
//return false;
}
}

function clickNS(e){
if (document.layers||document.getElementById&&!document.all){
if (e.which==2||e.which==3){
//alert(message);
//return false;
}
}
}

if (document.layers){
document.captureEvents(Event.MOUSEDOWN);
document.onmousedown=clickNS;
}
else if (document.all&&!document.getElementById){
document.onmousedown=clickIE;
}

//document.oncontextmenu=new Function("return false")

//------------------------------------------------------------------------------------------------------------------------
//END DISABLE RIGHT-CLICK button
//------------------------------------------------------------------------------------------------------------------------

    </script>

    <p align="center">
        <span style="position: absolute; left: 570px; top: 212px; z-index: 2; font-size: 8px;
            font-family: Arial;">Copyright &copy; Kalvin Ernst 2008 </span>
    </p>
    </form>
</body>
</html>
